#include <avr/io.h>

#include "strfmt.h"

uint8_t set_dec_point(char* s, uint8_t pos
#ifdef WITH_PAD_LEFT
					,uint8_t width, char fill
#endif
					)
{
	uint8_t len= 0;
	while (s[len] != '\0') len++;
	if (0 == len) return len;			// String mit Lnge==0
	
	uint8_t n;							// neue Lnge berechnen
	if (len <= pos) n= pos+2;			// Platz fr 0. 
	else n= len + (pos ? 1 : 0);		// Platz fr .
#ifdef WITH_PAD_LEFT
	if (width > n) n= width;			// width grer als Lnge
	else width= 0;						// sonst hat width keinen Effekt
#endif
	if (n == len) return len;			// nix zu tun
	uint8_t i= n;
	if (pos)							// DEC_POINT einfgen
	{
		while (pos--)					// Platz fr DEC_POINT schaffen
		{	
			char c= (len > 0) ? s[--len] : '0';
			s[--i]= c; 
		}
		s[--i]= DEC_POINT;
		if (0 == len) s[--i]= '0';	// 0.
	}
#ifdef WITH_PAD_LEFT
	if (width)
	{
		while (len > 0)
			s[--i]= s[--len];
		
		while (i > 0)
			s[--i]= fill;
	}
#endif
	s[n]= '\0';
	return n;						// Rckgabe: neue Lnge
}