#include <avr/io.h>

#include "Iir.h"

#define IIR_SHIFT 8	/* 8 binre Kommastellen */
#define IIR_ROUND_OFFS (1<<(IIR_SHIFT-1))
uint16_t IirFilter::Execute(uint16_t value)
{
	int32_t x= value;
	x<<= IIR_SHIFT;
	x= IirOld + ((x - IirOld + IIR_ROUND_OFFS) >> IIR_SHIFT) * IirK;
	IirOld= x;
	return (uint16_t)(x >> IIR_SHIFT);
}