#ifndef IIR_H_
#define IIR_H_

class IirFilter	{
private:
	uint8_t		IirK;
	int32_t		IirOld;
	
public:
	// param k:
	// Die Filterzeitkonstante kann fr kleine Werte von k relativ einfach als 1/k angenhert werden. 
	// mit k = 0 .. 256 entspricht 0.0 .. 1.0
	// k = 8, entspricht also 0.03125, die Zeitkonstante ist damit 32 Zyklen
	IirFilter(uint8_t k) { IirK= k; IirOld= 0; }
	uint16_t Execute(uint16_t value);
};

#endif /* IIR_H_ */