#ifndef AC_H_
#define AC_H_

#define AC_CTRL_PORT PORTB
#define AC_CTRL_DDR DDRB	/* do not change, OC1A is hardware dependent - Port B, bit 1*/
#define AC_CTRL_PIN PINB

#define AC_POLARTIY_PIN 0
#define AC_PWM_PIN 1		/* do not change, OC1A is hardware dependent - Port B, bit 1*/
#define AC_ENABLE_PIN 2

#define enable_ac() AC_CTRL_PORT|= (1<<AC_ENABLE_PIN)
#define disable_ac() AC_CTRL_PORT&= ~(1<<AC_ENABLE_PIN)

#ifdef __cplusplus
extern "C"	{
#endif

extern void init_ac();
extern void start_ac();

#ifdef __cplusplus
}
#endif

#endif /* AC_H_ */